/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1996, 1997  All Rights Reserved.                   *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 76 1.6.1.2 source/ographic/ioldgpl.hpp, graphics, ioc.v400, 980918 
// ioldgpl.hpp - Pragma Library definitions for old graphics

#ifndef _IOLDGPL_
#define _IOLDGPL_

#ifndef IC_IMPORTFG
  #if defined(__WINDOWS__) && defined(__IMPORTLIB__)
    #define IC_IMPORTFG  _Import
  #else
    #define IC_IMPORTFG
  #endif
#endif

/*-------------------------- Pragma Library Support --------------------------*/
#ifndef _IPRAGLIB_
#include <ipraglib.h>
#endif

#if !defined(__NO_DEFAULT_LIBS__)
    #if !defined(__NO_OLDGRAPHIC_LIB__)
        #if defined(__WINDOWS__)
            #if defined(_MSC_VER)   // MSVC
                    #pragma comment(lib, OPENCLASS_LIBRARY_NAME_2(graphic,fg))
            #else                   // VAC
                    #pragma library(OPENCLASS_LIBRARY_NAME_2(graphic,fg))
            #endif
        #elif defined(__OS2__)
                #pragma library(OPENCLASS_LIBRARY_NAME_2(graphic,fg))
        #endif // platform
    #else
        // This will be seen in the context of building the library only.
        #if defined(__WINDOWS__)
            #if defined(_MSC_VER)   // MSVC
                #pragma comment(lib, "gdi32.lib")
                #pragma comment(lib, "user32.lib")
            #else                   // VAC
                #pragma library("gdi32.lib")
                #pragma library("user32.lib")
            #endif
        #elif defined(__OS2__)
            #pragma library("os2386.lib")
        #endif
    #endif // __NO_OLDGRAPHIC_LIB__
#endif  // __NO_DEFAULT_LIBS__

#endif // _IOLDGPL_


